<?php
// Module that performs handling of registration form (register)
include_once ("../SYSTEM/MISC.PHP");
include_once ("../SYSTEM/CONSTS.PHP");
include_once ("../SYSTEM/STRING.PHP");
include_once ("../SYSTEM/DB_FUNCS.PHP");
include_once ("../SYSTEM/USERS.PHP");
include_once ("../SYSTEM/CHANNELS.PHP");

dbf_connect () or die (BZ_ERR_DATABASE_CONNECTION);

function dr_die ($str)
{
 echo $str."<br>";
 echo ('
 <a href="javascript:history.back()">...</a></br>
 <a href="../MODULES/LOGIN.PHP?'.getenv ("QUERY_STRING").'">  ...</a></br>
 ');
 misc_emit_copyright ();
 dbf_die ("");
}

// Validate fields:
// login
$in_login=trim (str_extract_form_input ($HTTP_POST_VARS['login']));
if (strlen ($in_login)<BZ_MIN_NAMES_LEN)
 dr_die (BZ_ERR_REG_NICK_EMPTY);

if (usr_find_user_login ($in_login))
 dr_die (BZ_ERR_REG_NICK_BUSY);

// password
$in_pass1=trim (str_extract_form_input ($HTTP_POST_VARS['password1']));
$in_pass2=trim (str_extract_form_input ($HTTP_POST_VARS['password2']));
if ((strlen ($in_pass1)<BZ_MIN_NAMES_LEN)||(strlen ($in_pass2)<BZ_MIN_NAMES_LEN))
 dr_die (BZ_ERR_REG_PASSWORD_EMPTY);
if ($in_pass1!=$in_pass2)
 dr_die (BZ_ERR_REG_PASSWORD_DIFF);

// color
$in_color=str_extract_form_input ($HTTP_POST_VARS['color']);

// private channel policy
$in_policy=str_extract_form_input ($HTTP_POST_VARS['pchn_policy']);

// private channel name
$in_pchn_name=str_extract_form_input ($HTTP_POST_VARS['pchn_name']);

// rules for private channel
$in_rules=str_multiline_to_html
 (substr (str_extract_form_input ($HTTP_POST_VARS['pchn_rules'],FALSE),0,BZ_MAX_RULES_LEN));

// ->> Register the thug!!! <<-
$uid=usr_add_user ($in_login,$in_pass1);
if ($uid==-1)
 dr_die (BZ_ERR_GENERIC_RETRY);
if ($uid==0)
 dr_die (BZ_ERR_REG_NICK_BUSY);

$user=usr_find_user_uid ($uid);
if (!$user)
{
 $rmv="<br>1".((usr_remove_user ($uid))? BZ_ERR_REG_CANCEL : BZ_ERR_REG_NOT_CANCEL);
 dr_die (BZ_ERR_REG_PARTIAL.$rmv);
}

$user->color=$in_color;

// Give him a private channel
$chid=chan_add_channel ($uid,$in_policy);
if ($chid==-1)
{
 $rmv="<br>(2)<br>".((usr_remove_user ($uid))? BZ_ERR_REG_CANCEL : BZ_ERR_REG_NOT_CANCEL);
 dr_die (BZ_ERR_REG_PARTIAL.$rmv);
}

// give him rights for the channel
if (!usr_give_channel ($uid,$chid))
{
 $rez=usr_remove_user ($uid) and chan_remove_channel ($chid);
 $rmv="<br>(3)<br>".(($rez)? BZ_ERR_REG_CANCEL : BZ_ERR_REG_NOT_CANCEL);
 dr_die (BZ_ERR_REG_PARTIAL.$rmv);
}

$chan=new TChannel;
$chan->c_index=$chid;
$chan->name=$in_pchn_name;
$chan->policy=$in_policy;

// adjust channel
if (!chan_edit_channel ($chan,$in_rules))
{
 $rez=usr_remove_user ($uid) and chan_remove_channel ($chid);
 $rmv="<br>(4)<br>".(($rez)? BZ_ERR_REG_CANCEL : BZ_ERR_REG_NOT_CANCEL);
 dr_die (BZ_ERR_REG_PARTIAL.$rmv);
}

// Harass the avatar picture
if (!$HTTP_POST_VARS['del_avatar'])
{
 if ($HTTP_POST_FILES['avafile']['name'])
 {
  if (!strcasecmp (substr ($HTTP_POST_FILES['avafile']['name'],-4),".gif"))
   $in_img_present=".gif";
  else
  if (!strcasecmp (substr ($HTTP_POST_FILES['avafile']['name'],-4),".jpg"))
   $in_img_present=".jpg";
  else
  if (!strcasecmp (substr ($HTTP_POST_FILES['avafile']['name'],-5),".jpeg"))
   $in_img_present=".jpeg";
  else
  {
   $in_img_present="-";
   echo BZ_ERR_REG_IMG_INCORRECT."<br>";
  }

  if ($in_img_present!="-")
  if ((!$HTTP_POST_FILES['avafile']['size'])||
  (!is_uploaded_file ($HTTP_POST_FILES['avafile']['tmp_name'])))
  {
   $in_img_present="-";
   echo BZ_ERR_REG_IMG_UPLOAD."<br>";
  }

  if ($in_img_present!="-")
  if (move_uploaded_file ($HTTP_POST_FILES['avafile']['tmp_name'],
  BZ_AVATAR_DIR.$user->uid.$in_img_present))
  {
   $user->img_present=$in_img_present;
   @chmod (BZ_AVATAR_DIR.$user->uid.$in_img_present,0666);
  }
  else
  echo BZ_ERR_REG_IMG_UPLOAD."<br>";
 }
}
else
{
 // as if no pict
 $user->img_present="-";
}

if (!usr_edit_profile ($user))
{
 $rmv="<br>(5)<br>".((usr_remove_user ($uid))? BZ_ERR_REG_CANCEL : BZ_ERR_REG_NOT_CANCEL);
 dr_die (BZ_ERR_REG_PARTIAL.$rmv);
}

dr_die (BZ_ERR_REG_OK);

?>