<?php
// Message handling
// dbf connection must be established before calling these funcs!
if (!defined ("MSGS"))
{
 define ("MSGS","(c)");
 include ("../SYSTEM/CONSTS.PHP");
 include ("../SYSTEM/SESSIONS.PHP");
 include ("../SYSTEM/STRING.PHP");

 class TMessage
 {
  var $channel_id;
  var $time;
  var $nick;
  var $author_id;
  var $ip;
  var $color;
  var $admin;
  var $img;
  var $text;
 };

 // msg_add_message ($session,$text,$adm=0)
 // Adds a message from usual user
 // Pars: session (TSession), message text, admin flag
 // Return: TRUE (success)/FALSE (not success)
 function msg_add_message ($session,$text,$adm=0)
 {
  //if (!$adm) $text=substr (str_limit_word_len ($text),0,BZ_MAX_UMESSAGE_LEN);
  return dbf_query ("INSERT INTO messages
  (
   channel_id,
   time,
   nick,
   author_id,
   ip,
   color,
   admin,
   img,
   text
  ) VALUES
  (
   ".$session->channel_id.",
   NOW(),
   '".$session->nick."',
   '".$session->author_id."',
   '".$session->ip."',
   '".$session->color."',
   $adm,
   '".$session->img_present."',
   '".str_multiline_to_html ($text)."'
  );
  ");
 }

 // msg_add_sys_message ($channel_id,$text)
 // Adds a message from chat system
 // Pars: channel id, message text, admin flag
 // Return: TRUE (success)/FALSE (not success)
 function msg_add_sys_message ($channel_id,$text)
 {
  //$text=substr (str_limit_word_len ($text),0,BZ_MAX_UMESSAGE_LEN);
  return dbf_query ("INSERT INTO messages
  (
   channel_id,
   time,
   nick,
   author_id,
   ip,
   color,
   admin,
   img,
   text
  ) VALUES
  (
   ".$channel_id.",
   NOW(),
   '".BZ_SYSTEM_NAME."',
   'sys',
   '".getenv ("REMOTE_ADDR")."',
   '".BZ_SYSTEM_MSG_COLOR."',
   1,
   '-',
   '".$text."'
  );
  ");
 }

 // msg_drop_expired_messages ()
 // Removes expired messages
 // Pars: none
 // Return: TRUE (success)/FALSE (not success)
 // Remarks: Yet always succeeds. Should be called as frequently as possible.
 function msg_drop_expired_messages ()
 {
  return dbf_query ("DELETE FROM messages WHERE
  (UNIX_TIMESTAMP(NOW())-UNIX_TIMESTAMP(time)>".MESSAGE_MAX_TTL.") or
  (UNIX_TIMESTAMP(time)-UNIX_TIMESTAMP(NOW())>".ONE_HOUR.");");
 }

 // msg_get_messages ($channel_id,$n_lines)
 // Gets messages of current channel in form suitable for output to chat log
 // Pars: channel id, lines per page
 // Return: array[n_lines] of TMessage's (including empty lines)
 function msg_get_messages ($channel_id,$n_lines)
 {
  $rez=array ();
  for ($i=0; $i<$n_lines; $i++)
  {
   $rez[$i]=new TMessage;
   $rez[$i]->channel_id=$channel_id;
   $rez[$i]->nick="&nbsp;";
   $rez[$i]->color="0";
   $rez[$i]->img="-";
   $rez[$i]->text="&nbsp;";
  }
  $n_logln=dbf_select_query ("SELECT
  ROUND(time) as time,
  nick,
  author_id,
  color,
  admin,
  img,
  text
  FROM messages WHERE
  (channel_id=$channel_id) and
  (UNIX_TIMESTAMP(NOW())-UNIX_TIMESTAMP(time)<".MESSAGE_MAX_TTL_LOG.")
  ORDER BY time DESC
  LIMIT $n_lines;");
  if ($n_logln>0)
  for ($i=0;;$i++)
  {
   $row=dbf_fetch_row ();
   if (!$row) break;
   $rez[$n_lines-$i-1]->time=$row['time'];
   $rez[$n_lines-$i-1]->nick=$row['nick'];
   $rez[$n_lines-$i-1]->author_id=
    ($row['author_id']{0}=='%')? $row['author_id'] : "-";
   $rez[$n_lines-$i-1]->color=$row['color'];
   $rez[$n_lines-$i-1]->admin=$row['admin'];
   $rez[$n_lines-$i-1]->img=$row['img'];
   $rez[$n_lines-$i-1]->text=$row['text'];
  }
  dbf_free_result ();
  return $rez;
 }

 // msg_get_all_messages ($channel_id)
 // Gets all messages of current channel
 // Pars: channel id, lines per page
 // Return: array[n_lines] of TMessage's (including empty lines)
 function msg_get_all_messages ($channel_id)
 {
  $rez=array ();
  $n_logln=dbf_select_query ("SELECT
  ROUND(time) as time,
  nick,
  author_id,
  ip,
  color,
  admin,
  img,
  text
  FROM messages WHERE
  (channel_id=$channel_id)
  ORDER BY time ASC;");
  if ($n_logln>0)
  for ($i=0;;$i++)
  {
   $row=dbf_fetch_row ();
   if (!$row) break;
   $rez[$i]->channel_id=$channel_id;
   $rez[$i]->time=$row['time'];
   $rez[$i]->nick=$row['nick'];
   $rez[$i]->author_id=$row['author_id'];
   $rez[$i]->ip=$row['ip'];
   $rez[$i]->color=$row['color'];
   $rez[$i]->admin=$row['admin'];
   $rez[$i]->img=$row['img'];
   $rez[$i]->text=$row['text'];
  }
  dbf_free_result ();
  return $rez;
 }
}
?>