<?php

// Functions to handle sessions

if (!defined ("SESSIONS"))
{
 include ("../SYSTEM/RANDOM.PHP");
 include ("../SYSTEM/DB_FUNCS.PHP");
 include ("../SYSTEM/STRING.PHP");
 include ("../SYSTEM/CONSTS.PHP");

 define ("SESSIONS","(c)");

 class TSession
 {
  var $channel_id;
  var $author_id;
  var $session_expiry;
  var $nick;
  var $ip;
  var $color;
  var $img_present;
  var $update_sec;
  var $lines_per_page;
  var $session_key;
  var $started_at;
  var $last_update;
  var $moder;
 };
 
 // sess_drop_expired_sessions ()
 // Removes expired sessions
 // Pars: none
 // Return: TRUE (success)/FALSE (not success)
 // Remarks: yet always TRUE. ;) Should be called as frequently as possible. :)))
 function sess_drop_expired_sessions ()
 {
  dbf_query
   ("DELETE FROM sessions WHERE (session_expiry<UNIX_TIMESTAMP(NOW()));");
  return TRUE;
 }

 // sess_add_session (& $session)
 // Adds a session
 // Pars: & $session - ref to TSession object (session_expiry & session_key need NOT
 //  to be set)
 // Return: FALSE (success)/string of error
 // Remarks: dbf_connection must be established!!!
 //  $session->session_key is set in case of success
 function sess_add_session (& $session)
 {
  if ($session->author_id{0}!='%')
  {
   $n=dbf_select_query
     ("SELECT nick FROM sessions WHERE ((nick='$session->nick') and (channel_id=$session->channel_id));");
   dbf_free_result ();
   if ($n==-1) return (BZ_ERR_DATABASE_CONNECTION);
   if ($n) return (BZ_ERR_NICK_BUSY);
  }
  for ($i=0; $i<10; $i++)
  {
   $n_session_key=rand (10000000,99999999);
   $n=dbf_select_query
    ("SELECT session_key FROM sessions WHERE (session_key)=$n_session_key;");
   dbf_free_result ();
   if ($n==-1) return (BZ_ERR_DATABASE_QUERY);
   if (!$n) break;
  }
  // 10 random numbers are all used by other sessions?? this is definitely very odd. %)
  if ($i>10) return (BZ_ERR_GENERIC_RETRY);
  list (,$sec)=explode (" ",microtime ());
  if (!dbf_query ("INSERT INTO sessions
  (
   session_key,
   channel_id,
   author_id,
   ip,
   nick,
   color,
   img_present,
   update_sec,
   lines_per_page,
   session_expiry,
   started_at,
   last_update,
   moder
  ) VALUES (
  "
  ."$n_session_key,"
  ."$session->channel_id,"
  ."'$session->author_id',"
  ."'$session->ip',"
  ."'$session->nick',"
  ."'$session->color',"
  ."'$session->img_present',"
  ."$session->update_sec,"
  ."$session->lines_per_page,"
  .($sec+SESSION_MAX_LENGTH).",
  UNIX_TIMESTAMP(NOW()),
  UNIX_TIMESTAMP(NOW()),"
  .$session->moder
  .");"
  )) return BZ_ERR_DATABASE_QUERY;
  $session->session_key=$n_session_key;
  return false;
 }

 // sess_get_sessions ($channel_id,& $errmsg)
 // Gets all current sessions (for a given channel, or all if channel_id==-1)
 // Pars: channel id, &$errmsg - ref to var for an error msg to be placed
 // Returns: array of TSession(s)
 // Remarks: $errmsg is set to FALSE if ok, otherwise - to error message
 function sess_get_sessions ($chid,& $errmsg)
 {
  $rez=array ();
  if (dbf_select_query ("SELECT
   session_key,
   channel_id,
   author_id,
   ip,
   nick,
   color,
   img_present,
   update_sec,
   lines_per_page,
   session_expiry,
   started_at,
   last_update,
   moder
  FROM sessions WHERE ((channel_id=$chid) or ($chid=-1))
  ORDER BY nick ASC;")==-1)
  {
   $errmsg=BZ_ERR_DATABASE_QUERY;
   return FALSE;
  }
  for ($i=0;;$i++)
  {
   $row=dbf_fetch_row ();
   if (!$row) break;
   $rez[$i]=new TSession;
   $rez[$i]->session_key=$row['session_key'];
   $rez[$i]->channel_id=$row['channel_id'];
   $rez[$i]->author_id=$row['author_id'];
   $rez[$i]->ip=$row['ip'];
   $rez[$i]->nick=$row['nick'];
   $rez[$i]->color=$row['color'];
   $rez[$i]->img=$row['img'];
   $rez[$i]->update_sec=$row['update_sec'];
   $rez[$i]->lines_per_page=$row['lines_per_page'];
   $rez[$i]->session_expiry=$row['session_expiry'];
   $rez[$i]->last_update=$row['last_update'];
   $rez[$i]->started_at=$row['started_at'];
   $rez[$i]->moder=$row['moder'];
  }
  $errmsg=FALSE;
  return $rez;
 }
 
 // sess_get_session ($session_key)
 // Gets particular session with a given session key
 // Pars: session key
 // Returns: TSession (success)/FALSE (not ok)
 // Remarks: in session->started_at returns session elapsed time in secs
 function sess_get_session ($session_key)
 {
  $rez=new TSession;
  if (dbf_select_query ("SELECT
   session_key,
   channel_id,
   author_id,
   ip,
   nick,
   color,
   img_present,
   update_sec,
   lines_per_page,
   session_expiry,
   (UNIX_TIMESTAMP(NOW())-started_at) as started_at,
   last_update,
   moder
  FROM sessions WHERE (session_key=$session_key);")<1)
   return FALSE;
  $row=dbf_fetch_row ();
  $rez->session_key=$row['session_key'];
  $rez->channel_id=$row['channel_id'];
  $rez->author_id=$row['author_id'];
  $rez->ip=$row['ip'];
  $rez->nick=$row['nick'];
  $rez->color=$row['color'];
  $rez->img_present=$row['img_present'];
  $rez->update_sec=$row['update_sec'];
  $rez->lines_per_page=$row['lines_per_page'];
  $rez->session_expiry=$row['session_expiry'];
  $rez->started_at=$row['started_at'];
  $rez->last_update=$row['last_update'];
  $rez->moder=$row['moder'];
  return $rez;
 }

 // sess_drop_session_author_id ($channel_id,$author_id)
 // Removes session w/given author_id
 // Pars: channel ID (or -1 for all), author ID
 // Return: TRUE (success)/FALSE (not success)
 function sess_drop_session_author_id ($channel_id,$author_id)
 {
  dbf_query
   ("DELETE FROM sessions WHERE ( (author_id='$author_id') and
    ((channel_id=$channel_id) or ($channel_id=-1)) );");
  return TRUE;
 }

 // sess_drop_session_key ($session_key)
 // Removes session w/given session_key
 // Pars: session key
 // Return: TRUE (success)/FALSE (not success)
 function sess_drop_session_key ($session_key)
 {
  dbf_query ("DELETE FROM sessions WHERE (session_key=$session_key);");
  return TRUE;
 }
 
 // sess_touch_session ($session_key)
 // Refreshes session w/given key
 // Pars: session key
 // Return: TRUE (success)/FALSE (not success - no access/session expired)
 function sess_touch_session ($session_key)
 {
  // find if session exists
  if (dbf_select_query ("SELECT session_key FROM sessions WHERE (session_key=$session_key);")<1)
   return FALSE;
  dbf_free_result ();

  // update it
  //list (,$unow)=explode (" ",microtime ());
  dbf_query
   ("UPDATE sessions SET
    session_expiry=(UNIX_TIMESTAMP(NOW())+".SESSION_MAX_LENGTH."),
    last_update=UNIX_TIMESTAMP(NOW())
    WHERE
    (session_key=$session_key);");
  return TRUE;
 }
}
?>