<?php

// String manipulation auxiliary routines

if (!defined ("STRINGS"))
{
 define ("STRINGS","(c)",TRUE);

 // str_extract_form_input ($fi_str,$trim_nps=TRUE)
 // Extract string from input forms. Replace dangerous symbols w/safe ones. Remove exess backslashes.
 // Pars: source string, trim_nps: if TRUE all symbols w/code<32 are replaced w/spaces.
 // Return: result
 function str_extract_form_input ($fi_str,$trim_nps=TRUE)
 {
  $fi_str=stripslashes ($fi_str);
  
  $l=strlen ($fi_str);
  for ($i=0; $i<$l; $i++) // as the PHP str_replace glucks with single quotes
  {
   if (ord ($fi_str{$i})==39) $fi_str{$i}="`";
  }
  if ($trim_nps)
  for ($i=0; $i<$l; $i++) // replace nonprintable symbols w/whitespaces
  {
   if (ord ($fi_str{$i})<32) $fi_str{$i}=" ";
  }
  return str_replace ("%","&#37",
   str_replace ("\"","&#34",
    str_replace ("\\","&#92",
     str_replace ("<","&#60",
      str_replace (">","&#62",
       str_replace ("`","&#96",
        str_replace ("&","&#38",
         $fi_str
        )
       )
      )
     )
    )
   )
  );
 }
 
 // str_limit_word_len ($sstr)
 // Breaks too long (>BZ_MAX_WORD_LEN) words by inserting dashes (ascii 45).
 // Pars: source string
 // Return: result
 function str_limit_word_len ($sstr)
 {
  $rez="";
  $count=0;
  $len=strlen ($sstr);
  for ($i=0; $i<$len; $i++, $count++)
  {
   $rez.=$sstr{$i};
   if (((ord ($sstr{$i})>=0)&&(ord ($sstr{$i})<=32))||($sstr{$i}=='-')) $count=0;
   if ($count>BZ_MAX_WORD_LEN)
   {
    $count=0;
    $rez.=" ";
   }
  }
  return $rez;
 }

 // str_get_params ($qstr)
 // Explode URL query string (url.php?qstr) into associative array of params
 // ?par1=val1&par2=val2&par3=val3 explodes into:
 // $arr['par1']=val1; $arr['par2']=val2; $arr['par3']=val3
 // Pars: query string
 // Return: associative array of params
 function str_get_params ($qstr)
 {
  $rez=array ();
  $arrpar=explode ("&",$qstr);
  foreach ($arrpar as $par)
  {
   list ($key,$val)=explode ("=",$par);
   $rez[$key]=$val;
  }
  return $rez;
 }

 // str_multiline_to_html ($str)
 // Converts multiline string into multiline html code (replace \n-s w/<br>-s)
 // Pars: string
 // Return: converted string
 function str_multiline_to_html ($str)
 {
  return str_replace (chr (10),"<br>",
   str_replace (chr (13),"",$str));
 }

 // str_html_to_multiline ($str)
 // Converts multiline string into multiline html code (replace \n-s w/<br>-s)
 // Pars: string
 // Return: converted string
 function str_html_to_multiline ($str)
 {
  return str_replace ("&#38","&",
   str_replace ("&#34","\"",
    str_replace ("&#92","\\",
     str_replace ("&#60","<",
      str_replace ("&#62",">",
       str_replace ("&#96","`",
        str_replace ("&#37","%",
         str_replace ("<br>",chr (10),$str)
        )
       )
      )
     )
    )
   )
  );
 }
}
?>