<?php

// User handling funcs

if (!defined ("USERS"))
{
 define ("USERS","(c)");

 include_once ("../SYSTEM/CONSTS.PHP");
 include_once ("../SYSTEM/DB_FUNCS.PHP");
 include_once ("../SYSTEM/CHANNELS.PHP");
 include_once ("../SYSTEM/MISC.PHP");

 class TUser
 {
  var $uid;
  var $nick;
  var $color;
  var $pchannel_id;
  var $img_present; // empty or '-' for n/a, extension (.gif/.jpg/.jpeg) otherwise
  var $last_entered;
 };

 // usr_find_user ($login,$pwd)
 // Finds user by login & password
 // Pars: login, password
 // Returns: FALSE (not found)/struct TUser filled w/data
 function usr_find_user ($login,$pwd)
 {
  if (!$pwd) return FALSE;
  $q=dbf_select_query
   ("SELECT u_index,nick,color,img_present,pchannel_id,UNIX_TIMESTAMP(last_entered) as last_entered FROM users WHERE
     ( (nick='$login') and (pass=PASSWORD('$pwd')) );");
  if ($q>0)
  {
   $q=dbf_fetch_row ();
   $rez=new TUser;
   $rez->uid=$q['u_index'];
   $rez->nick=$q['nick'];
   $rez->color=$q['color'];
   $rez->img_present=$q['img_present'];
   $rez->pchannel_id=$q['pchannel_id'];
   $rez->last_entered=$q['last_entered'];
   dbf_free_result ();
   return $rez;
  }
  else
  return FALSE;
 }

 // usr_find_user_uid ($uid)
 // Finds user by uid
 // Pars: uid
 // Returns: FALSE (not found)/struct TUser filled w/data
 function usr_find_user_uid ($uid)
 {
  $q=dbf_select_query
   ("SELECT u_index,nick,color,img_present,pchannel_id,UNIX_TIMESTAMP(last_entered) as last_entered FROM users WHERE
     (u_index=$uid);");
  if ($q>0)
  {
   $q=dbf_fetch_row ();
   $rez=new TUser;
   $rez->uid=$q['u_index'];
   $rez->nick=$q['nick'];
   $rez->color=$q['color'];
   $rez->img_present=$q['img_present'];
   $rez->pchannel_id=$q['pchannel_id'];
   $rez->last_entered=$q['last_entered'];
   dbf_free_result ();
   return $rez;
  }
  else
  return FALSE;
 }

 // usr_find_user_login ($login)
 // Finds user by login
 // Pars: login
 // Returns: FALSE (not found)/struct TUser filled w/data
 function usr_find_user_login ($login)
 {
  $q=dbf_select_query
   ("SELECT u_index,nick,color,img_present,UNIX_TIMESTAMP(last_entered) as last_entered FROM users WHERE nick='$login';");
  if ($q)
  {
   $q=dbf_fetch_row ();
   $rez=new TUser;
   $rez->uid=$q['u_index'];
   $rez->nick=$q['nick'];
   $rez->color=$q['color'];
   $rez->img_present=$q['img_present'];
   $rez->last_entered=$q['last_entered'];
   dbf_free_result ();
   return $rez;
  }
  else
  return FALSE;
 }

 // usr_get_all_users ()
 // Gets all users and places them into associative (by '%uid') array of TUser
 // Pars: login
 // Returns: FALSE (error)/array of TUser filled w/data
 function usr_get_all_users ()
 {
  $q=dbf_select_query
   //("SELECT u_index,nick,color,img_present,last_entered FROM users ORDER BY u_index ASC;");
   ("SELECT u_index,nick,color,img_present,UNIX_TIMESTAMP(last_entered) as last_entered FROM users ORDER BY last_entered DESC;");
  if ($q>=0)
  {
   $rez=array ();
   for (;;)
   {
    $row=dbf_fetch_row ();
    if (!$row) break;
    $rez['%'.$row['u_index']]=new TUser;
    $rez['%'.$row['u_index']]->uid=$row['u_index'];
    $rez['%'.$row['u_index']]->nick=$row['nick'];
    $rez['%'.$row['u_index']]->color=$row['color'];
    $rez['%'.$row['u_index']]->img_present=$row['img_present'];
    $rez['%'.$row['u_index']]->last_entered=$row['last_entered'];
   }
   dbf_free_result ();
   return $rez;
  }
  else
  return FALSE;
 }

 // usr_get_last_users ($n_users)
 // Gets N last registered users and places them into associative (by '%uid') array of TUser
 // Pars: login
 // Returns: FALSE (error)/array of TUser filled w/data
 function usr_get_last_users ($n_users)
 {
  $q=dbf_select_query
   ("SELECT u_index,nick,color,img_present,UNIX_TIMESTAMP(last_entered) as last_entered FROM users ORDER BY last_entered DESC LIMIT $n_users;");
  if ($q>=0)
  {
   $rez=array ();
   for (;;)
   {
    $row=dbf_fetch_row ();
    if (!$row) break;
    $rez['%'.$row['u_index']]=new TUser;
    $rez['%'.$row['u_index']]->uid=$row['u_index'];
    $rez['%'.$row['u_index']]->nick=$row['nick'];
    $rez['%'.$row['u_index']]->color=$row['color'];
    $rez['%'.$row['u_index']]->img_present=$row['img_present'];
    $rez['%'.$row['u_index']]->last_entered=$row['last_entered'];
   }
   dbf_free_result ();
   return $rez;
  }
  else
  return FALSE;
 }

 // usr_touch_user ($uid)
 // Updates user's "last entered" field
 // Pars: user id
 // Returns: TRUE (ok)/FALSE (not ok)
 function usr_touch_user ($uid)
 {
  return dbf_query ("UPDATE users SET last_entered=NOW() WHERE u_index=$uid;");
 }

 // usr_get_channel_status ($uid,$channel_id)
 // Finds user statuses (mod,smod,bl,wl) for current channel
 // Pars: user id, channel id
 // Return: bool array of statuses
 // ([BZ_USER_BLACK/WHITELIST], [BZ_USER_MOD], [BZ_USER_SUPERMOD], or FALSE on error)
 function usr_get_channel_status ($uid,$channel_id)
 {
  $rez=dbf_select_query ("SELECT
  user_id,
  channel_id,
  state
  FROM user_stat
  WHERE
  (user_id=$uid) and
  ((channel_id=$channel_id) or
  (channel_id=-1));");
  if ($rez==-1) return FALSE;
  $arr=array ();
  list (
  $arr[BZ_USER_BLACKLISTED],
  $arr[BZ_USER_WHITELISTED],
  $arr[BZ_USER_MOD],
  $arr[BZ_USER_SUPERMOD])=array (FALSE,FALSE,FALSE,FALSE);
  for (;;)
  {
   $row=dbf_fetch_row ();
   if (!$row) break;
   switch ($row['state'])
   {
    case (BZ_USER_BLACKLISTED):
     $arr[BZ_USER_BLACKLISTED]=TRUE;
    break;

    case (BZ_USER_WHITELISTED):
     $arr[BZ_USER_WHITELISTED]=TRUE;
    break;

    case (BZ_USER_MOD):
     $arr[BZ_USER_MOD]=TRUE;
    break;

    case (BZ_USER_SUPERMOD):
     $arr[BZ_USER_SUPERMOD]=TRUE;
    break;
   }
  }
  dbf_free_result ();
  return $arr;
 }

 // usr_set_channel_status ($uid,$chid,$ostatus,$status)
 // Sets statuses for user on current channel (mod,smod,bl,wl)
 // Pars: uid, channel id, array of old statuses (as in return of usr_get_channel_status),
 // array of new statuses. If $ostatus is FALSE, it is taken from DB
 // 1: set; 0: reset; -1: no changes
 // Returns: num of statuses successfully changed, not counting "not changed" (0 to 4)
 function usr_set_channel_status ($uid,$chid,$ostatus,$nstatus)
 {
  $sc_cnt=0;
  if (!$ostatus)
   $ostatus=usr_get_channel_status ($uid,$chid);
  if (!$ostatus) return 0;
  if (($nstatus[BZ_USER_BLACKLISTED]==1)&&($ostatus[BZ_USER_BLACKLISTED]))
   $sc_cnt++;
  if (($nstatus[BZ_USER_BLACKLISTED]==0)&&(!$ostatus[BZ_USER_BLACKLISTED]))
    $sc_cnt++;
  if (($nstatus[BZ_USER_BLACKLISTED]==0)&&($ostatus[BZ_USER_BLACKLISTED]))
  {
  if (dbf_query
   ("DELETE FROM user_stat WHERE
    (user_id=$uid) and
    (channel_id=$chid) and
    (state=".BZ_USER_BLACKLISTED.");"))
   $sc_cnt++;
  }
  if (($nstatus[BZ_USER_BLACKLISTED]==1)&&(!$ostatus[BZ_USER_BLACKLISTED]))
  if (dbf_query ("INSERT INTO user_stat
  (user_id,channel_id,state)
  VALUES
  ($uid,$chid,".BZ_USER_BLACKLISTED.");"))
   $sc_cnt++;

  if (($nstatus[BZ_USER_WHITELISTED]==1)&&($ostatus[BZ_USER_WHITELISTED]))
   $sc_cnt++;
  if (($nstatus[BZ_USER_WHITELISTED]==0)&&(!$ostatus[BZ_USER_WHITELISTED]))
    $sc_cnt++;
  if (($nstatus[BZ_USER_WHITELISTED]==0)&&($ostatus[BZ_USER_WHITELISTED]))
  if (dbf_query
   ("DELETE FROM user_stat WHERE
    (user_id=$uid) and
    (channel_id=$chid) and
    (state=".BZ_USER_WHITELISTED.");"))
   $sc_cnt++;
  if (($nstatus[BZ_USER_WHITELISTED]==1)&&(!$ostatus[BZ_USER_WHITELISTED]))
  if (dbf_query ("INSERT INTO user_stat
  (user_id,channel_id,state)
  VALUES
  ($uid,$chid,".BZ_USER_WHITELISTED.");"))
   $sc_cnt++;

  if (($nstatus[BZ_USER_MOD]==1)&&($ostatus[BZ_USER_MOD]))
   $sc_cnt++;
  if (($nstatus[BZ_USER_MOD]==0)&&(!$ostatus[BZ_USER_MOD]))
    $sc_cnt++;
  if (($nstatus[BZ_USER_MOD]==0)&&($ostatus[BZ_USER_MOD]))
  if (dbf_query
   ("DELETE FROM user_stat WHERE
    (user_id=$uid) and
    (channel_id=$chid) and
    (state=".BZ_USER_MOD.");"))
   $sc_cnt++;
  if (($nstatus[BZ_USER_MOD]==1)&&(!$ostatus[BZ_USER_MOD]))
  if (dbf_query ("INSERT INTO user_stat
  (user_id,channel_id,state)
  VALUES
  ($uid,$chid,".BZ_USER_MOD.");"))
   $sc_cnt++;

  if (($nstatus[BZ_USER_SUPERMOD]==1)&&($ostatus[BZ_USER_SUPERMOD]))
   $sc_cnt++;
  if (($nstatus[BZ_USER_SUPERMOD]==0)&&(!$ostatus[BZ_USER_SUPERMOD]))
    $sc_cnt++;
  if (($nstatus[BZ_USER_SUPERMOD]==0)&&($ostatus[BZ_USER_SUPERMOD]))
  if (dbf_query
   ("DELETE FROM user_stat WHERE
    (user_id=$uid) and
    (state=".BZ_USER_SUPERMOD.");"))
   $sc_cnt++;
  if (($nstatus[BZ_USER_SUPERMOD]==1)&&(!$ostatus[BZ_USER_SUPERMOD]))
  if (dbf_query ("INSERT INTO user_stat
  (user_id,channel_id,state)
  VALUES
  ($uid,-1,".BZ_USER_SUPERMOD.");"))
   $sc_cnt++;

  return $sc_cnt;
 }

 // usr_get_all_channel_status ($channel_id)
 // Gets statuses on current channel for all users
 // Pars: channel id
 // Return: array of TUser class, to which is added member $status - array of statuses (on success)
 // or FALSE (on failure)
 function usr_get_all_channel_status ($channel_id)
 {
  $rez=usr_get_all_users ();
  if (!misc_test_arr ($rez)) return FALSE;
  foreach ($rez as $user)
  {
   $user->status=array ();
   list (
   $user->status[BZ_USER_BLACKLISTED],
   $user->status[BZ_USER_WHITELISTED],
   $user->status[BZ_USER_MOD],
   $user->status[BZ_USER_SUPERMOD])=array (FALSE,FALSE,FALSE,FALSE);
  }
  $i=dbf_select_query
   ("SELECT user_id,state FROM user_stat WHERE
    (channel_id=$channel_id) or (channel_id=-1)");
  if ($i<0) return FALSE;
  for (;;)
  {
   $row=dbf_fetch_row ();
   if (!$row) break;
   $rez["%".$row['user_id']]->status[$row['state']]=TRUE;
  }
  dbf_free_result ();
  return $rez;
 }

 // usr_add_user ($login,$password)
 // Adds new user to database
 // Pars: login, password
 // Return: uid (or 0, if user exists, or -1 if error)
 function usr_add_user ($login,$password)
 {
  // test if such user already exists
  $rez=dbf_select_query
   ("SELECT u_index FROM users WHERE nick='".$login."';");
  if ($rez==-1) return -1;
  if ($rez>0) return 0;
  dbf_query ("INSERT INTO users
  (nick,pass,last_entered) VALUES ('".$login."',PASSWORD('".$password."'),NOW());");
  $rez=dbf_select_query
   ("SELECT u_index FROM users WHERE nick='".$login."';");
  if ($rez<1) return -1;
  $uid_arr=dbf_fetch_row ();
  dbf_free_result ();
  return $uid_arr['u_index'];
 }

 // usr_remove_user ($owner_id)
 // Removes reg. data for user with given id and all related things
 // Pars: owner id
 // Returns: number of deletion stages performed (ok, of total 6)/0 (not ok)
 function usr_remove_user ($owner_id)
 {
  $user=usr_find_user_uid ($owner_id);
  if (!$user) return 0;
  //echo BZ_AVATAR_DIR.$owner_id.".*<br>";
  $rez=0;
  $rez+=dbf_query ("DELETE FROM messages WHERE author_id='%".$owner_id."';")? 1 : 0;
  $rez+=dbf_query ("DELETE FROM sessions WHERE author_id='%".$owner_id."';")? 1 : 0;
  $rez+=dbf_query ("DELETE FROM awards WHERE (author_id='%".$owner_id."') or (issuer_id=$owner_id);")? 1 : 0;
  $rez+=dbf_query ("DELETE FROM user_stat WHERE user_id=$owner_id;")? 1 : 0;
  if ($user->pchannel_id>0)
  {
   if (chan_remove_channel ($user->pchannel_id)) $rez++;
   else return $rez;
  }
  else
   $rez++;
  $rez+=dbf_query ("DELETE FROM users WHERE u_index=$owner_id;")? 1 : 0;
  if ($user->img_present{0}==".")
   @unlink (BZ_AVATAR_DIR.$owner_id.$user->img_present); // delete avatar picture
  return $rez;
 }

 // usr_give_pchannel ($uid,$pchannel_id)
 // Gives user a channel w/given channel id
 // Pars: user id, channel id
 // Returns: TRUE (ok)/FALSE (not ok)
 function usr_give_channel ($uid,$pchannel_id)
 {
  if (!dbf_query
  ("UPDATE users SET
  pchannel_id=$pchannel_id
  WHERE u_index=$uid;")) return FALSE;
  $arr=array ();
  list (
  $arr[BZ_USER_BLACKLISTED],
  $arr[BZ_USER_WHITELISTED],
  $arr[BZ_USER_SUPERMOD])=-1;
  $arr[BZ_USER_MOD]=1;
  return usr_set_channel_status ($uid,$pchannel_id,FALSE,$arr);
 }

 // usr_edit_profile ($new_profile)
 // Modifies user profile
 // Pars: TUser ($nick,$color,$img_present are significant)
 // Returns: TRUE (ok)/FALSE (not ok)
 function usr_edit_profile ($new_profile)
 {
  return (dbf_query
  ("UPDATE users SET
   nick='".$new_profile->nick."',
   color='".$new_profile->color."',
   img_present='".$new_profile->img_present."'
   WHERE u_index=".$new_profile->uid.";")) &&
  ((dbf_query
  ("UPDATE messages SET
   img='".$new_profile->img_present."'
   WHERE author_id='%".$new_profile->uid."';")) &&
  (dbf_query
  ("UPDATE sessions SET
   img_present='".$new_profile->img_present."'
   WHERE author_id='%".$new_profile->uid."';")));
 }

 // usr_change_password ($uid,$newpass)
 // Modifies user profile - sets new password
 // Pars: uid, new password
 // Returns: TRUE (ok)/FALSE (not ok)
 function usr_change_password ($uid,$newpass)
 {
  return dbf_query
  ("UPDATE users SET
   pass=PASSWORD('".$newpass."')
   WHERE u_index=".$uid.";");
 }
}
?>